package journal.action;

import java.util.SortedSet;
import java.util.TreeSet;

import journal.reader.DataJournalEntry;
import journal.schema.TableVersion;

public class UserLister extends BaseAction {

	@Override
	public void putValue(DataJournalEntry data) throws Exception {
		TableVersion version = data.getTableVersion();

		String user = null;
		
		if( version.getAttributeByName("user") != null ) {
			user = (String) data.getValue("user");
		}
		else if( version.getAttributeByName("owner") != null ) {
			user = (String) data.getValue("owner");
		}

		if( user != null && ! user.equals("")) {
			if( options.isCaseInsensitive() ) {
				user = user.toLowerCase();
			}
			if( ! uniqueUsers.contains(user)) {
				uniqueUsers.add(user);
			}
		}
	}
	
	@Override
	public void finish() throws Exception  {
		for( String user : uniqueUsers) {
			out.println(user + "=");
		}
		if( outputFile != "" ) {
			out.close();
		}
	}
	

	SortedSet<String> uniqueUsers = new TreeSet<String>();
}
