package journal.action.sql;

import java.util.HashMap;
import java.util.Map;

import journal.schema.Domain;

/**
 * SupportedDatabase
 * 
 * Lists all supported databases.
 * Simply a convenient placeholder for the type-mappings 
 * defined in journal.schema.Domain
 * 
 * @author Sven Erik Knop
 *
 */

public enum SupportedDatabase {
	MySQL,
	SQLite,
	Oracle,
	PostgreSQL;
	
	public void defineMapping(Domain d, String type) {
		mapping.put(d, type);
	}
	
	public String getMapping(Domain d) {
		return mapping.get(d);
	}
	
	final Map<Domain, String> mapping = new HashMap<Domain, String>();
}
