/**
 * 
 */
package journal.reader;

import java.util.EnumSet;

import journal.action.Action;

public enum ActionType {
	PUT_VALUE("pv") { void invoke(Action action, JournalEntry entry)  throws Exception { action.putValue((DataJournalEntry) entry); } },
	REPLACE_VALUE("rv") { void invoke(Action action, JournalEntry entry)  throws Exception { action.replaceValue((DataJournalEntry) entry); } },
	DELETE_VALUE("dv") { void invoke(Action action, JournalEntry entry)  throws Exception { action.deleteValue((DataJournalEntry) entry); } },
	VERIFY_VALUE("vv") { void invoke(Action action, JournalEntry entry)  throws Exception { action.verifyValue((DataJournalEntry) entry); } },
	FLUSH_MARKER("mx") { void invoke(Action action, JournalEntry entry)  throws Exception { action.flushMarker((TransactionJournalEntry) entry); } },
	COMMIT_MARKER("ex") { void invoke(Action action, JournalEntry entry)  throws Exception { action.commitMarker((TransactionJournalEntry) entry); } },
	NOTE_MARKER("nx") { void invoke(Action action, JournalEntry entry) throws Exception { action.journalMarker((NoteJournalEntry) entry); } },
	DELETE_MARKER("dl") { void invoke(Action action, JournalEntry entry) throws Exception { action.deleteMarker((DeleteJournalEntry) entry); } };
	
	final String symbol;
	static public final EnumSet<ActionType> TransactionAction = EnumSet.of(FLUSH_MARKER, COMMIT_MARKER);
	
	public String symbol() { return symbol; }
	
	ActionType(String symbol) {
		this.symbol = symbol;
	}
	
	abstract void invoke(Action action, JournalEntry entry) throws Exception;
}